#include "matrix.h"

/* 単位行列をつくる */
Matrix IdentityMatrix={1,0,0,
		       0,1,0,
		       0,0,1};

/* 拡大縮小行列をつくる */
Matrix ScaleMatrix(const double scaleX,const double scaleY,const double scaleZ){
    Matrix t=IdentityMatrix;
    t.m11=scaleX;
    t.m22=scaleY;
    t.m33=scaleZ;
    return t;
}

/* ベクトル-行列積 */
Vector tVectorMatrix(const Vector v,const Matrix m){
    Vector vec;
    /* Complete the following code */
	
	vec.x = v.x * m.m11 + v.y * m.m21 + v.z * m.m31;
	vec.y = v.x * m.m12 + v.y * m.m22 + v.z * m.m32;
	vec.z = v.x * m.m13 + v.y * m.m23 + v.z * m.m33;

    return vec;
}

/* 行列-ベクトル積 */
Vector MatrixVector(const Matrix m,const Vector v){
    Vector vec;
    /* Complete the following code */
	vec.x = v.x * m.m11 + v.y * m.m12 + v.z * m.m13;
	vec.y = v.x * m.m21 + v.y * m.m22 + v.z * m.m23;
	vec.z = v.x * m.m31 + v.y * m.m32 + v.z * m.m33;
    return vec;
}
