#include<stdio.h>
#include<math.h>
#include<X11/Xlib.h>
#include<X11/Xutil.h>
#include "incim.h"

#include "vector.h"
#include "matrix.h"
#include "color.h"
#include "ellipse.h"

#define MAXELLIPSE  512
#define SCREEN_SIZE 256

main(){
	int Screen;	/* スクリーンの大きさ */
	int MaxX,MaxY;
	int ix,iy;	/* スクリーン上の位置 */

	Vector E;	/* 視点の座標 */
	Vector F;	/* 視線の終点の座標 */
	Vector V;	/* 視線方向ベクトル */

	double t;	/* 視点から交点までの距離=２次方程式の解 */
	double mint;	/* 視点から交点までの最短距離 */

	Ellipse Obj[MAXELLIPSE];
	int	n;	/* シーンを構成する楕円面の数 */
	int	i;	/* 処理中の楕円面の番号 */
	int	mins;	/* 視線と交差する球の番号 */

	Color bgcol;	/* 背景色=球が見えなかったときの色 */
	Color tmpcol;	/* 輝度を求めるための作業変数 */

	/*
 	 * 楕円面の方程式や反射モデルのデータなどを標準入力から読み込む
 	 */

	/* 背景色(球が見えなかったときの色) */
	scanf( "%d %d %d\n",&bgcol.r,&bgcol.g,&bgcol.b );

	/* シーンを構成する楕円面の数 */
	scanf( "%d",&n );

	/* 楕円面のデータ 中心位置座標,半径,色,反射係数等 */
	for(i=0;i<n;i++){
	  scanf("%lf %lf %lf %lf %lf %lf %d %d %d %lf %lf %lf %lf\n",
		&Obj[i].pos.x,&Obj[i].pos.y,&Obj[i].pos.z,
		&Obj[i].a,&Obj[i].b,&Obj[i].c,
		&Obj[i].color.r,&Obj[i].color.g,&Obj[i].color.b,	
		&Obj[i].ka,&Obj[i].kd,&Obj[i].ks,&Obj[i].n );
	}

	/* ウインドウの設定 */
	Screen=SCREEN_SIZE;
	MaxX = (Screen-1)/2;
	MaxY = MaxX;
	openwindow(Screen,Screen,"ray13",1);

	/*
 	 * 光線追跡
 	 */
	for(iy=MaxY;iy>=-MaxY;iy--){
	  for (ix=-MaxX; ix<=MaxX; ix++){ 

		/* 光線の方程式 */
		E.x=0;		E.y=0;		E.z=700;/* 光線の始点(視点) */
		F.x=(double)ix;	F.y=(double)iy;	F.z=0;	/* 光線の終点の位置座標 */
		V=sub(F,E);
		V=normalize(V);	/* 光線の方向余弦ベクトル */

		/* 画素毎の初期設定 */
		mint=1000000;	/* 視点からの距離を無限遠方に設定する */
		mins=-1;	/* 視線と交差する楕円面の番号を-1に設定する
				   楕円面の番号は0からであるので
				   視線と交差する楕円面はないことになる */
		tmpcol=bgcol;	/* 視線と交差しない場合の背景の色を設定する */

		/*
		* すべての楕円面に対して，
		* 各楕円面と視線(光線)とが交差するかどうか調べる。
		* 交差した場合，視点から交点までの距離を求める。
		* 求めた距離がそれまでの最短距離であった場合，
		* 最短距離と楕円面の番号を更新する。
		*/
		for (i=0; i<n; i++){ 
			t=calcEllipseT(Obj[i],E,V);
			/* 求めた距離がそれまでの最短距離であった場合 */
			if ((t>0) && (t<=mint)){ 
				mint=t;	/* 最短距離を更新する */
				mins=i;	/* 楕円面の番号を更新する */
			}
		}
		/* 交点があった場合，楕円面の色を現在の画素として設定する */
		if (mins>=0){
			tmpcol.r=(int)(Obj[mins].color.r); 
			tmpcol.g=(int)(Obj[mins].color.g);
			tmpcol.b=(int)(Obj[mins].color.b);
		}
		/* 画素の色を設定する  */
		setfgcolorbyRGB(tmpcol.r,tmpcol.g,tmpcol.b);
		/* 画素を描画する */
		setpixel(ix+MaxX,-iy+MaxY+1);
	  }
	}	/* End of Loop */
 	keepwindow ();	/* Windowを表示し続ける */
	closewindow();	/* Windowを閉じる */
}	/* End of "main" */
