#ifndef __SHADING_H
#define __SHADING_H

#include "ellipse.h"
#include "vector.h"
#include "color.h"

/*----------------------------------------------------------------------*/
/* 陰影計算を行う							*/
/* src:対象となる楕円 	Q:光源						*/
/* P:交点 		N:交点における法線 	E:視点の位置		*/
/* ia:環境光強度 	id:拡散光強度		is:鏡面反射光強度	*/
/*----------------------------------------------------------------------*/
extern void calcShading(const Ellipse src, const PointLight Q,
			const Vector P, const Vector N, const Vector E,
			double *ia, double *id, double *is);

#endif

