#include <math.h>
#include "vector.h"

double length(const Vector v){
	double leng;
	leng=sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
	return(leng);
}

Vector normalize(const Vector v){
	Vector tmp;
	double leng;
	leng = length(v);
	tmp.x = v.x/leng;
	tmp.y = v.y/leng;
	tmp.z = v.z/leng;
	return(tmp);
}

Vector neg(const Vector v){
	Vector tmp;
	tmp.x = -v.x;
	tmp.y = -v.y;
	tmp.z = -v.z;
	return(tmp);
}

Vector scale(const double a,const Vector v){
	Vector tmp;
	tmp.x = a * v.x;
	tmp.y = a * v.y;
	tmp.z = a * v.z;
	return(tmp);
}

Vector sub(const Vector a,const Vector b){
	Vector v;

	v.x = a.x - b.x;
	v.y = a.y - b.y;
	v.z = a.z - b.z;
	
	return(v);
}


Vector add(const Vector a,const Vector b){
	Vector v;
	
	v.x = a.x + b.x;
	v.y = a.y + b.y;
	v.z = a.z + b.z;
	
	return(v);
}

double dot(const Vector a,const Vector b){
	double d;
	
	d = a.x*b.x + a.y*b.y + a.z*b.z;
	
	return(d);
}
