#ifndef __VECTOR_H
#define __VECTOR_H

/*ベクトル構造体*/
typedef struct{
	double x;
	double y;
	double z;
}Vector;

/*-----------------------------------------------------------------------------
 * 指定されたベクトル（v）の長さを返す
 *---------------------------------------------------------------------------*/
extern double length(const Vector v);

/*-----------------------------------------------------------------------------
 * 指定されたベクトル（v）を正規化する
 *---------------------------------------------------------------------------*/
extern Vector normalize(const Vector v);

/*-----------------------------------------------------------------------------
 * 指定されたベクトル（v）を指定された値（a）でスケーリングしたベクトルを返す
 *---------------------------------------------------------------------------*/
extern Vector scale(const double a, Vector v);

/*-----------------------------------------------------------------------------
 * ベクトル（v）の逆ベクトル-vを返す
 *---------------------------------------------------------------------------*/
extern Vector neg(const Vector v);

/*-----------------------------------------------------------------------------
 * 指定されたベクトルaからbを引いた差ベクトルを返す
 *---------------------------------------------------------------------------*/
extern Vector sub(const Vector a,const Vector b);

/*-----------------------------------------------------------------------------
 * 指定されたベクトルaとbの和ベクトルを返す
 *---------------------------------------------------------------------------*/
extern Vector add(const Vector a,const Vector b);

/*-----------------------------------------------------------------------------
 * 指定されたベクトル（a,b）の内積を返す
 *---------------------------------------------------------------------------*/
extern double dot(const Vector a,const Vector b);

#endif

